/* indybot - Copyright (C) 2004 bakunin - <bakunin@autistici.org>
 *
 * This source code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Public License as published 
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This source code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * Please refer to the GNU Public License for more details.
 *
 * You should have received a copy of the GNU Public License along with
 * this source code; if not, write to:
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#else
# error Use configure; make; make install
#endif

#include <indybot.h>

void
add_channel (const char *chan, char *file)
{
  struct channel *tmp;
  register int i;

  if (!chan || !file)
    fatal ("Error in config files o internal error.");

  if (!(tmp = (struct channel *) malloc (sizeof (struct channel))))
    fatal ("Error: memory.");

  if (*chan == '#')
    {
      if (!(tmp->channel = strdup (chan)))
	fatal ("Error: memory.");
    }
  else
    {
      if (!
	  (tmp->channel =
	   (char *) malloc (sizeof (char) * (strlen (chan) + 2))))
	fatal ("Error: memory.");

      *tmp->channel = '#';
      memcpy (tmp->channel + 1, chan, strlen (chan));
      *(tmp->channel + strlen (chan) + 2) = 0;
    }

  if (!strncmp (file, "http", 4))
    {
      if (!(tmp->file = strdup (file)))
	fatal ("Error: memory.");

    }
  else
    {
      if (!
	  (tmp->file = (char *) malloc (sizeof (char) * (strlen (file) + 7))))
	fatal ("Error: memory.");

      sprintf (tmp->file, "http://%s", file);

    }

  for (i = 0; i < MAX_NEWS; i++)
    tmp->old_id[i] = tmp->new_id[i] = 0;

  tmp->next = channels;
  channels = tmp;
}

int
del_channel (const char *chan)
{
  struct channel *tmp, *prev;
  int i = 0;

  if (!chan)
    fatal ("Internal error.");

  tmp = channels;
  prev = NULL;

  while (tmp)
    {

      if (*chan ==
	  '#' ? !strcmp (tmp->channel, chan) : !strcmp (tmp->channel + 1,
							chan))
	{
	  free (tmp->channel);
	  free (tmp->file);

	  if (!prev)
	    channels = tmp->next;
	  else
	    prev->next = tmp->next;

	  free (tmp);

	  i = 1;
	}

      prev = tmp;
      tmp = tmp->next;
    }

  if (i)
    return 0;

  return 1;
}

int
save_channels (void)
{
  FILE *fl;
  struct channel *tmp;

  if (!(fl = fopen (file_cfg, "wb")))
    return 1;

  fprintf (fl, "Nick = \"%s\"\n", nick);
  fprintf (fl, "Server = \"%s\"\n", server);
  fprintf (fl, "Port = \"%d\"\n", port);
  fprintf (fl, "Ssl = %s\n", secure ? "true" : "false");
  fprintf (fl, "Password = \"%s\"\n", password);
  fprintf (fl, "Timer = %d\n", timer);
  fprintf (fl, "XmlPath = \"%s\"\n", xmlpath);

  tmp = channels;

  while (tmp)
    {

      fprintf (fl, "Channel \"%s\" {\n\tFile = \"%s\"\n}\n\n", tmp->channel,
	       tmp->file);

      tmp = tmp->next;
    }

  fclose (fl);

  return 0;
}
