/* indybot - Copyright (C) 2004 bakunin - <bakunin@autistici.org>
 *
 * This source code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Public License as published 
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This source code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * Please refer to the GNU Public License for more details.
 *
 * You should have received a copy of the GNU Public License along with
 * this source code; if not, write to:
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <sys/types.h>
#include <libxml/xmlmemory.h>
#include <libxml/parser.h>
#include <curl/curl.h>
#include <curl/types.h>
#include <curl/easy.h>
#include <sys/socket.h>
#include <netdb.h>
#include <termios.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <pthread.h>
#include <confuse.h>

#ifdef HAVE_LIBSSL
#include <openssl/ssl.h>
#include <openssl/bio.h>
#endif

#ifdef HAVE_LIBRECODE
#include <stdbool.h>
#include <recode.h>
#endif

#define AUTHOR "bakunin - bakunin@autistici.org"

#define SIZE_BUFFER 1024
#define MAX_NEWS 5

struct MemoryStruct
{
  char *mm;
  size_t size;
};

struct newswire
{
  char *title;
  char *url;
  char *time;
  char *author;
  char *department;
  char *topic;
  char *comments;
  char *section;
  char *image;
};

struct post {
  int id;
  char *date;
  char *link;
  char *url;
  char *mime;
  int comments;
  char *author;
  char *title;
  char *summary;
};

struct channel
{
  char *channel;
  char *file;

  unsigned int old_id[MAX_NEWS];

  unsigned int new_id[MAX_NEWS];

  struct channel *next;
};

#ifdef HAVE_LIBSSL
extern BIO *bio;
#endif

extern int fd, check_time, check_write;
extern pthread_mutex_t mutex;
extern char line[SIZE_BUFFER];
extern int fill;

extern char *file_cfg;
extern int debug;

extern char *nick;
extern char *server;
extern char *password;
extern char *xmlpath;
extern int port;
extern int timer;
extern int secure;
extern int set_quit;

#ifdef HAVE_LIBRECODE
extern RECODE_REQUEST request;
#endif

extern struct channel *channels;

size_t memorize_file (void *, size_t, size_t, void *);
void parseStory (xmlDocPtr, xmlNodePtr, struct channel *);
struct MemoryStruct *download_file(char *);
void parse (void *, size_t, struct channel *);
void check (struct channel *);
void *thread_xml (void *);
void fatal (const char *);
size_t get_line (char *);
char *check_cmd (char *);
char *check_part (char *);
void irc_socket (void);
char *trim (char *);
void set_nick (void);
void set_channel (void);
void add_channel (const char *chan, char *file);
int del_channel (const char *chan);
int save_channels(void);
void usage (void);
int get_id (char *);
size_t irc_write (void *, size_t);
size_t irc_read (void *, size_t);
void query_check (char *, char *);
void query_help (char *);
void query_info(char *, int);
void query_search(char *,int, int, int, int, int, char *, char *, char *, int, int, int);
struct post *info(int);
struct post *info_check(void *, size_t);
void info_write(char *, struct post *);
int search_check(char *, void *, size_t);
void search_write(char *, struct post *, int *);
char *recode(char *);
