/* indybot - Copyright (C) 2004 bakunin - <bakunin@autistici.org>
 *
 * This source code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Public License as published 
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This source code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * Please refer to the GNU Public License for more details.
 *
 * You should have received a copy of the GNU Public License along with
 * this source code; if not, write to:
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#else
# error Use configure; make; make install
#endif

#include <indybot.h>
#define MAX 20

void
query_check (char *who, char *str)
{
  char output[SIZE_BUFFER];
  static char a[MAX][MAX];
  int j, k, w;
  register int i;
  int len;


  if (!str)
    {
      len =
	snprintf (output, SIZE_BUFFER, "PRIVMSG %s :Syntax error.\n", who);
      irc_write (output, len);

      return;
    }

  if (*str == ':')
    str++;
  str = trim (str);

  for (i = 0; i < MAX; i++)
    a[i][0] = 0;

  i = j = k = w = 0;

  while (*str)
    {

      if (!w)
	while ((*str == ' ' || *str == '\t' || *str == '=') && *str)
	  {
	    *str = 0;
	    k = 1;
	    str++;
	  }

      if (k == 1 || (w && (*str == '"' || *str == '\'')))
	{

	  a[j][i] = 0;

	  j++;
	  i = 0;

	  if (j >= MAX)
	    break;
	}

      if (k != 2)
	{
	  if (*str == '"' || *str == '\'')
	    w = 1;
	  else
	    a[j][i++] = *str;

	  k = 0;
	}

      if (i >= MAX)
	k = 2;

      str++;
    }

  a[j][i] = 0;

  if (!strcmp (a[0], "help"))
    {
      query_help (who);
      return;
    }

  if (!strcmp (a[0], "info"))
    {
      if (!a[1] || !atoi (a[1]))
	{
	  len =
	    snprintf (output, SIZE_BUFFER,
		      "PRIVMSG %s :Syntax error. Write 'help'.\n", who);
	  irc_write (output, len);

	}
      else
	query_info (who, atoi (a[1]));

    }


  else if (!strcmp (a[0], "search"))
    {

      int limit = 0, page = 0, hidden = 0, id = 0, comments = 0;
      int year = 0, month = 0, day = 0;
      char *author = NULL, *keyword = NULL, *sort = NULL;

      for (i = 1; i < j + 1; i++)
	{
	  if (!strcmp (a[i], "keyword") && a[i + 1])
	    keyword = strdup (a[++i]);

	  else if (!strcmp (a[i], "comments") && a[i + 1])
	    comments = atoi (a[++i]);

	  else if (!strcmp (a[i], "id_request") && a[i + 1])
	    id = atoi (a[++i]);

	  else if (!strcmp (a[i], "hidden") && a[i + 1])
	    hidden = !strcmp (a[++i], "yes") || !strcmp (a[++i], "1") ? 1 : 0;

	  else if (!strcmp (a[i], "author") && a[i + 1])
	    author = strdup (a[++i]);

	  else if (!strcmp (a[i], "page") && a[i + 1])
	    page = atoi (a[++i]);

	  else if (!strcmp (a[i], "limit") && a[i + 1])
	    limit = atoi (a[++i]);

	  else if (!strcmp (a[i], "sort") && a[i + 1])
	    if (!strcmp (a[++i], "modified") || !strcmp (a[i], "rank")
		|| !strcmp (a[i], "reverse"))
	      sort = strdup (a[i]);
	    else
	      {
		len =
		  snprintf (output, SIZE_BUFFER,
			    "PRIVMSG %s :Sort error: i know only: modified, rank, reverse. Write 'help'.\n",
			    who);
		irc_write (output, len);

		i = MAX + 1;

	      }
	  else if (!strcmp (a[i], "year") && a[i + 1])
	    year = atoi (a[++i]);

	  else if (!strcmp (a[i], "month") && a[i + 1])
	    month = atoi (a[++i]);

	  else if (!strcmp (a[i], "day") && a[i + 1])
	    day = atoi (a[++i]);

	  else
	    {
	      len =
		snprintf (output, SIZE_BUFFER,
			  "PRIVMSG %s :Syntax error: %s. Write 'help'.\n",
			  who, a[i]);
	      irc_write (output, len);

	      i = MAX + 1;
	    }
	}

      if (i <= MAX)
	query_search (who, id, limit, page, hidden, comments, author, keyword,
		      sort, year, month, day);

      if (author)
	free (author);

      if (keyword)
	free (keyword);

      if (sort)
	free (sort);
    }

  else if (!strcmp (a[0], "add"))
    {
      if (!a[1] || !a[2] || !a[3])
	len =
	  snprintf (output, SIZE_BUFFER,
		    "PRIVMSG %s :Syntax error. Write 'help'.\n", who);

      else if (strcmp (a[1], password))
	len =
	  snprintf (output, SIZE_BUFFER,
		    "PRIVMSG %s :Password error. Write 'help'.\n", who);

      else
	{
	  add_channel (a[2], a[3]);
	  set_channel ();

	  if (save_channels ())
	    len =
	      snprintf (output, SIZE_BUFFER,
			"PRIVMSG %s :Done but i'm not able to write the config file.\n",
			who);

	  else
	    len = snprintf (output, SIZE_BUFFER, "PRIVMSG %s :Done.\n", who);
	}

      irc_write (output, len);

    }

  else if (!strcmp (a[0], "del"))
    {

      if (!a[1] || !a[2])
	len =
	  snprintf (output, SIZE_BUFFER,
		    "PRIVMSG %s :Syntax error. Write 'help'.\n", who);

      else if (strcmp (a[1], password))
	len =
	  snprintf (output, SIZE_BUFFER,
		    "PRIVMSG %s :Password error. Write 'help'.\n", who);

      else
	{
	  if (del_channel (a[2]))
	    len =
	      snprintf (output, SIZE_BUFFER,
			"PRIVMSG %s :I'm no inside this channel.\n", who);

	  else
	    {
	      set_channel ();

	      if (save_channels ())
		len =
		  snprintf (output, SIZE_BUFFER,
			    "PRIVMSG %s :Done but i'm not able to write the config file.\n",
			    who);

	      else
		len =
		  snprintf (output, SIZE_BUFFER, "PRIVMSG %s :Done.\n", who);

	    }
	}
      irc_write (output, len);
    }
  else if (!strcmp (a[0], "quit"))
    {

      if (!a[1])
	len =
	  snprintf (output, SIZE_BUFFER,
		    "PRIVMSG %s :Syntax error. Write 'help'.\n", who);

      else if (strcmp (a[1], password))
	len =
	  snprintf (output, SIZE_BUFFER,
		    "PRIVMSG %s :Password error. Write 'help'.\n", who);

      else
	{
	  set_quit = 1;
	  len = snprintf (output, SIZE_BUFFER, "QUIT :Indybot %s\n", VERSION);
	}

      irc_write (output, len);
    }

  else
    {
      len =
	snprintf (output, SIZE_BUFFER,
		  "PRIVMSG %s :Syntax error. Write 'help'.\n", who);

      irc_write (output, len);

    }

}

void
query_help (char *who)
{
  char output[SIZE_BUFFER];
  int len;

  len =
    snprintf (output, SIZE_BUFFER, "PRIVMSG %s :indybot %s - %s\n", who,
	      VERSION, AUTHOR);
  irc_write (output, len);

  len = snprintf (output, SIZE_BUFFER, "PRIVMSG %s : \n", who);
  irc_write (output, len);

  len =
    snprintf (output, SIZE_BUFFER,
	      "PRIVMSG %s :help -    questo menu di comandi\n", who);
  irc_write (output, len);

  len =
    snprintf (output, SIZE_BUFFER,
	      "PRIVMSG %s :info ID - Mostra i dati legati al post ID.\n",
	      who);
  irc_write (output, len);

  len =
    snprintf (output, SIZE_BUFFER,
	      "PRIVMSG %s :          l'ID lo puoi scoprire dal nome della pagina.\n",
	      who);
  irc_write (output, len);

  len =
    snprintf (output, SIZE_BUFFER,
	      "PRIVMSG %s :search -  Ricerca dei post nel database di indymedia.\n",
	      who);
  irc_write (output, len);

  len =
    snprintf (output, SIZE_BUFFER,
	      "PRIVMSG %s :          Per ricercare si puo' usare uno o piu' di questi parametri:\n",
	      who);
  irc_write (output, len);

  len =
    snprintf (output, SIZE_BUFFER,
	      "PRIVMSG %s :          author=AUTHOR - limit=LIMIT - page=PAGE - hidden=1/0\n",
	      who);
  irc_write (output, len);

  len =
    snprintf (output, SIZE_BUFFER,
	      "PRIVMSG %s :          comments=NUMBER - keyword=KEYWORD - sort=modified/rank/reverse\n",
	      who);
  irc_write (output, len);

  len =
    snprintf (output, SIZE_BUFFER,
	      "PRIVMSG %s :          year=YEAR - month=MONTH - day=DAY\n",
	      who);
  irc_write (output, len);

  len =
    snprintf (output, SIZE_BUFFER,
	      "PRIVMSG %s :add pass CHAN URL - attiva i miei servizi per il canale #CHAN\n",
	      who);
  irc_write (output, len);

  len =
    snprintf (output, SIZE_BUFFER,
	      "PRIVMSG %s :          legati alla pagina URL di indymedia. La pagina URL\n",
	      who);
  irc_write (output, len);

  len =
    snprintf (output, SIZE_BUFFER,
	      "PRIVMSG %s :          deve essere formattata correttamente in XML.\n",
	      who);
  irc_write (output, len);

  len =
    snprintf (output, SIZE_BUFFER,
	      "PRIVMSG %s :del pass CHAN - disattiva i servizi per il canale CHAN.\n",
	      who);
  irc_write (output, len);

  len =
    snprintf (output, SIZE_BUFFER, "PRIVMSG %s :quit pass - esce.\n", who);
  irc_write (output, len);
}

void
query_info (char *who, int id)
{
  struct post *tmp;
  char output[SIZE_BUFFER];
  int len;

  tmp = info (id);

  if (!tmp)
    {
      len =
	snprintf (output, SIZE_BUFFER, "PRIVMSG %s :Id non esistente.\n",
		  who);
      irc_write (output, len);

      return;
    }

  info_write (who, tmp);
  free (tmp);
}

void
query_search (char *who, int id, int limit, int page, int hidden,
	      int comments, char *author, char *keyword, char *sort, int year,
	      int month, int day)
{
  int len;
  char file[SIZE_BUFFER];
  struct MemoryStruct *chunk;

  if (id)
    query_info (who, id);

  len = 0;

  len = snprintf (file, SIZE_BUFFER - len, "%s?", xmlpath);

  if (!limit)
    limit = 5;

  len += snprintf (file + len, SIZE_BUFFER - len, "limit=%d&", limit);

  if (page)
    len += snprintf (file + len, SIZE_BUFFER - len, "page=%d&", page);

  if (hidden)
    len += snprintf (file + len, SIZE_BUFFER - len, "hidden=1&");

  if (comments)
    len += snprintf (file + len, SIZE_BUFFER - len, "comments=%d&", comments);

  if (author)
    len += snprintf (file + len, SIZE_BUFFER - len, "author=%s&", author);

  if (keyword)
    len += snprintf (file + len, SIZE_BUFFER - len, "keyword=%s&", keyword);

  if (sort)
    len += snprintf (file + len, SIZE_BUFFER - len, "sort=%s&", sort);

  if (year)
    len += snprintf (file + len, SIZE_BUFFER - len, "year=%d&", year);

  if (month)
    len += snprintf (file + len, SIZE_BUFFER - len, "month=%d&", month);

  if (day)
    len += snprintf (file + len, SIZE_BUFFER - len, "day=%2d&", day);

  chunk = download_file (file);

  if (debug)
    fprintf (stderr, "Info search file: %s\n", file);

  if (!(chunk = download_file (file)))
    {
      len = snprintf (file, SIZE_BUFFER, "No result.");

      irc_write (file, len);

      return;
    }

  if (!search_check (who, chunk->mm, chunk->size))
    return;

  free (chunk->mm);
  free (chunk);

  return;
}
